From d42f2eaf8b1a283efaa87b64d9bb8d3db48d3b5d Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:41:17 +0000
Subject: [PATCH 873/1001] Create a backend for the Feed widget and the My Stream page


---

diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index 50ba5ef..16bcbd1 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -30,6 +30,7 @@ import sys
 import retask.queue
 
 import hubs.app
+import hubs.feed
 import hubs.models
 import hubs.widgets.base
 
@@ -39,7 +40,7 @@ fedmsg_config = hubs.app.fedmsg_config
 session = hubs.app.session
 
 
-def triage(outbound, msg):
+def triage(msg):
     topic = msg['topic']
 
     for suffix in fedmsg_config['hubs.junk_suffixes']:
@@ -47,14 +48,22 @@ def triage(outbound, msg):
             log.debug("  Dropping junk %r", topic)
             return
 
-    # Get a list of all our widgets:
-    log.debug("Querying for all widgets.")
-    widgets = session.query(hubs.models.Widget).all()
+    # Handle user notifications.
+    if ".fmn.notification." in topic:  # XXX: use the proper topic pattern when it's chosen
+        yield retask.task.Task(json.dumps({
+            'type': 'notification',
+            'msg': msg,
+        }))
+        return  # Notifications don't appear anywhere else, stop here.
 
-    # Randomize so that all the triage daemons work on widgets in different
-    # orders.  This should hopefully prevent cache thrashing.
-    log.debug("Randomizing list of all widgets.")
-    random.shuffle(widgets)
+    # Store the list of concerned hubs to check later in the
+    # should_invalidate() method of Feed widgets.
+    msg["_hubs"] = hubs.feed.get_hubs_for_msg(msg)
+
+    # Store the message for the Feed widgets.
+    hubs.feed.on_new_message(msg)
+
+    widgets = get_widgets()
 
     def is_widget_update(msg, widget):
         """Always rebuild the cache when the widget config is updated."""
@@ -64,15 +73,29 @@ def triage(outbound, msg):
     log.debug("Checking should_invalidate for all widgets.")
     for widget in widgets:
         for fn_name, fn_class in widget.module.get_cached_functions().items():
-            if is_widget_update(msg, widget) or \
-                    fn_class(widget).should_invalidate(msg):
+            # log.debug("Checking %s:%s", widget.plugin, widget.idx)
+            fn = fn_class(widget)
+            if is_widget_update(msg, widget) or fn.should_invalidate(msg):
                 yield retask.task.Task(json.dumps({
+                    'type': 'widget-cache',
                     'idx': widget.idx,
                     'fn_name': fn_name,
                     'msg_id': msg['msg_id'],
                 }))
 
 
+def get_widgets():
+    # Get a list of all our widgets:
+    log.debug("Querying for all widgets.")
+    widgets = session.query(hubs.models.Widget).all()
+    # Randomize so that all the triage daemons work on widgets in different
+    # orders.  This should hopefully prevent cache thrashing.
+    log.debug("Randomizing list of all widgets.")
+    random.shuffle(widgets)
+    # TODO: cache the widgets list until a widget is added or deleted?
+    return widgets
+
+
 def main(args=None):
     args = args if args is not None else sys.argv
     logging.config.dictConfig(fedmsg_config['logging'])
@@ -102,7 +125,7 @@ def main(args=None):
                 inbound.length, outbound.length, msg['msg_id'], msg['topic'],
             )
             with hubs.app.app.app_context():  # so url_for works
-                for task in triage(outbound, msg):
+                for task in triage(msg):
                     log.debug("  Triage sending %r to workers." % task)
                     outbound.enqueue(task)
             log.debug("  Done with triage of %r.", msg['msg_id'])
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
index 30c55bc..5e82bda 100755
--- a/hubs/backend/worker.py
+++ b/hubs/backend/worker.py
@@ -34,6 +34,7 @@ import sys
 import retask.queue
 
 import hubs.app
+import hubs.feed
 import hubs.models
 import hubs.widgets.base
 
@@ -43,7 +44,7 @@ fedmsg_config = hubs.app.fedmsg_config
 session = hubs.app.session
 
 
-def work(widget_idx, fn_name):
+def widget_cache_work(widget_idx, fn_name):
     # Get a real widget, because we update last_refreshed on it.
     widget = hubs.models.Widget.by_idx(widget_idx)
     fn_class = widget.module.get_cached_functions()[fn_name]
@@ -53,11 +54,10 @@ def work(widget_idx, fn_name):
     # TODO -- fire off an EventSource notice that we updated stuff
 
 
-def handle(idx, fn_name):
-
+def handle_widget_cache(widget_idx, fn_name):
     try:
         with hubs.app.app.app_context():  # so url_for works
-            work(idx, fn_name)
+            widget_cache_work(widget_idx, fn_name)
         session.commit()  # transaction is committed here
     except:
         session.rollback()  # rolls back the transaction
@@ -78,6 +78,10 @@ def main(args=None):
     log.info("Worker starting, connecting to retask queue %r." % name)
     queue = retask.queue.Queue(name)
     queue.connect()
+    sse_name = fedmsg_config['hubs.redis.sse-queue-name']
+    log.info("Worker starting, connecting to retask queue %r." % sse_name)
+    sse_queue = retask.queue.Queue(sse_name)
+    sse_queue.connect()
 
     try:
         log.info("Entering work loop.")
@@ -85,7 +89,23 @@ def main(args=None):
             task = queue.wait()  # Wait forever...  timeout is optional.
             log.info("Working on %r.  (backlog is %r)" % (task, queue.length))
             item = json.loads(task.data)
-            handle(item['idx'], item['fn_name'])
+            sse_task = None
+            item_type = item.get("type", "widget-cache")
+            if item_type == "widget-cache":
+                handle_widget_cache(item['idx'], item['fn_name'])
+                sse_task = {
+                    "event": "hubs:widget-updated",
+                    "data": item["idx"],
+                }
+            elif item_type == "notification":
+                hubs.feed.on_new_notification(item["msg"])
+                username = fedmsg.meta.msg2agent(msg)
+                sse_task = {
+                    "event": "hubs:new-notification",
+                    "data": username,
+                }
+            if sse_task is not None:
+                sse_queue.enqueue(retask.task.Task(json.dumps(sse_task)))
             log.debug("  Done.")
     except KeyboardInterrupt:
         pass
diff --git a/hubs/default_fedmsg_config.py b/hubs/default_fedmsg_config.py
index 648f504..7cf088d 100644
--- a/hubs/default_fedmsg_config.py
+++ b/hubs/default_fedmsg_config.py
@@ -9,6 +9,7 @@ config = {
     # For communication between fedmsg-hub and the cache worker farm
     'hubs.redis.triage-queue-name': 'fedora-hubs-triage-queue',
     'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
+    'hubs.redis.sse-queue-name': 'fedora-hubs-sse-queue',
 
     # Junk junk junk.. that we don't care about.  Drop it!
     'hubs.junk_suffixes': [
diff --git a/hubs/feed.py b/hubs/feed.py
new file mode 100644
index 0000000..786844b
--- /dev/null
+++ b/hubs/feed.py
@@ -0,0 +1,181 @@
+from __future__ import unicode_literals
+
+import hashlib
+import logging
+import os
+
+import fedmsg.meta
+import redis
+from fedmsg.encoding import loads, dumps
+
+import hubs.app
+from hubs.models import Hub, User, Association
+
+
+log = logging.getLogger(__name__)
+
+
+def get_hubs_for_msg(msg):
+    hubs = []
+    for username in fedmsg.meta.msg2usernames(msg):
+        user = User.query.get(username)
+        # Only act on existing users
+        if user is None:
+            log.debug("Message concerning an unknown user: %s", username)
+            continue
+        hubs.append(username)
+        group_hubs = Hub.query.filter(
+                Hub.user_hub == False,  # noqa:E712
+            ).join(Association).filter(
+                Association.user == user,
+                Association.role.in_(["owner", "member"]),
+            )
+        hubs.extend([result[0] for result in group_hubs.values(Hub.name)])
+    return hubs
+
+
+def on_new_notification(msg):
+    """Only for FMN messages."""
+    username = fedmsg.meta.msg2agent(msg)
+    user = User.query.get(username)
+    # Only act on existing users
+    if user is None:
+        log.debug("Notification for an unknown user: %s", username)
+        return
+    # Users may exists without their hub if they have never logged
+    # in but are just added to the members list.  Don't check that
+    # the user Hub actually exists, it will be created when the user
+    # logs in, and this way the feed will be already populated.
+    log.debug("Received a notification concerning %s", username)
+    feed = Notifications(username)
+    feed.add(msg)
+
+
+def on_new_message(msg):
+    for hub_name in msg["_hubs"]:
+        log.debug("Received a feed item for hub %s", hub_name)
+        feed = Activity(hub_name)
+        feed.add(msg)
+
+
+def format_msg(msg):
+    if "msg_ids" not in msg:
+        msg = fedmsg.meta.conglomerate([msg])[0]
+    # Compute a deterministic dom_id.  Since this is the identifier stored
+    # when the message is saved by the user in the SQL DB, it has to be
+    # invariant through conglomerate() calls.
+    msg["dom_id"] = hashlib.sha1(
+        b":".join(
+            [mid.encode("utf-8") for mid in msg["msg_ids"]]
+        )).hexdigest()
+    # TODO: generate markup
+    msg["markup"] = msg["subtitle"]
+    msg["markup_subjective"] = msg["subjective"]
+    return msg
+
+
+class Feed(object):
+
+    max_items = 100
+    connection_pool = None
+    msgtype = None
+
+    def __init__(self, owner):
+        """
+        Args:
+            owner (str): User name or Hub name.
+        """
+        if self.msgtype is None:
+            raise NotImplementedError(
+                "You must subclass Feed and set self.msgtype.")
+        self.owner = owner
+        self.db = None
+        fedmsg_config = hubs.app.fedmsg_config
+        self.db_config = {
+            'host': fedmsg_config.get('hubs.redis.host', 'localhost'),
+            'port': fedmsg_config.get('hubs.redis.port', 6379),
+            'db': fedmsg_config.get('hubs.redis.db', 0),
+            'password': fedmsg_config.get('hubs.redis.password', None),
+            }
+        self.key = self._get_key()
+
+    def _get_key(self):
+        parts = ["feed", self.msgtype, self.owner]
+        key_prefix = hubs.app.fedmsg_config.get('hubs.redis.feed-prefix')
+        if key_prefix:
+            parts.insert(0, key_prefix)
+        return "|".join(parts)
+
+    def get(self, start=0, end=None):
+        end = end or -1
+        if self.db is None:
+            self.connect()
+        return [
+            loads(item.decode("utf-8")) for item in
+            self.db.lrange(self.key, start, end)
+            ]
+
+    def add(self, msg):
+        if self.db is None:
+            self.connect()
+        log.debug("Adding message %s to %s", msg["msg_id"], self.key)
+        self.db.lpush(self.key, dumps(self._format_msg(msg)))
+        self.db.ltrim(self.key, 0, self.max_items)
+
+    def length(self):
+        if self.db is None:
+            self.connect()
+        return self.db.llen(self.key)
+
+    __len__ = length
+
+    def connect(self):
+        if self.connection_pool is None:
+            self.connection_pool = redis.ConnectionPool(**self.db_config)
+        self.db = redis.Redis(connection_pool=self.connection_pool)
+        try:
+            self.db.info()
+        except redis.exceptions.ConnectionError:
+            log.warning("Could not connect to Redis")
+            self.db = None
+            raise  # XXX: do better?
+
+    def close(self):
+        try:
+            self.db.close()
+        except redis.exceptions.ConnectionError:
+            log.warning("Could not disconnect from Redis")
+            raise  # XXX: do better?
+        self.db = None
+        self.connection_pool = None
+
+
+class Notifications(Feed):
+
+    msgtype = "notif"
+
+    def _format_msg(self, msg):
+        return format_msg(msg)
+
+
+class Activity(Feed):
+
+    msgtype = "activity"
+
+    def _format_msg(self, msg):
+        # No-op, we want raw messages in the DB to conglomerate and format them
+        # later.
+        return msg
+
+
+def _load_json(username):
+    """This loads dummy data in the feeds."""
+    here = os.path.dirname(os.path.abspath(__file__))
+    with open(os.path.join(here, 'actions.json')) as fp:
+        msgs = loads(fp.read())
+    for feed_class in (Notifications, Activity):
+        feed = feed_class(username)
+        if feed.db is None:
+            feed.connect()
+        for msg in msgs:
+            feed.db.rpush(feed.key, dumps(msg))
diff --git a/hubs/tests/test_feed.py b/hubs/tests/test_feed.py
new file mode 100644
index 0000000..29b21ba
--- /dev/null
+++ b/hubs/tests/test_feed.py
@@ -0,0 +1,119 @@
+from __future__ import unicode_literals
+
+import json
+
+from mock import Mock, patch
+
+from hubs.app import app
+from hubs.models import User, Hub, Association
+from hubs.feed import (
+    Notifications, Activity, format_msg, get_hubs_for_msg,
+    on_new_message, on_new_notification)
+from hubs.tests import APPTest
+
+
+class FeedTest(APPTest):
+
+    def setUp(self):
+        super(FeedTest, self).setUp()
+        self.feed_classes = [
+            (Notifications, "notif"),
+            (Activity, "activity"),
+            ]
+
+    def tearDown(self):
+        super(FeedTest, self).tearDown()
+
+    def test_get(self):
+        for feed_class, msgtype in self.feed_classes:
+            feed = feed_class("testuser")
+            feed.db = Mock()
+            feed.db.lrange.return_value = []
+            feed.get()
+            feed.db.lrange.assert_called_once_with(
+                "feed|{}|testuser".format(msgtype), 0, -1)
+
+    def test_add(self):
+        msg = {
+            "msg_id": "testid",
+            "topic": "test.topic.dummy.value",
+            "timestamp": 123456789,
+            "testkey": "testvalue",
+            }
+        for feed_class, msgtype in self.feed_classes:
+            feed = feed_class("testuser")
+            feed.db = Mock()
+            key = "feed|{}|testuser".format(msgtype)
+            feed.add(msg)
+            feed.db.lpush.assert_called_once()
+            lpush_call_args = feed.db.lpush.call_args_list[0][0]
+            self.assertEqual(lpush_call_args[0], key)
+            if feed_class == Notifications:
+                self.assertIn("msg_ids", json.loads(lpush_call_args[1]))
+            elif feed_class == Activity:
+                self.assertEqual(json.loads(lpush_call_args[1]), msg)
+            feed.db.ltrim.assert_called_once_with(key, 0, 100)
+
+    def test_length(self):
+        for feed_class, msgtype in self.feed_classes:
+            feed = feed_class("testuser")
+            feed.db = Mock()
+            feed.db.llen.return_value = 42
+            self.assertEqual(feed.length(), 42)
+            feed.db.llen.assert_called_once_with(
+                "feed|{}|testuser".format(msgtype))
+
+    def test_close(self):
+        for feed_class, msgtype in self.feed_classes:
+            feed = feed_class("testuser")
+            redis_mock = feed.db = Mock()
+            feed.close()
+            redis_mock.close.assert_called_once()
+            self.assertIsNone(feed.db)
+            self.assertIsNone(feed.connection_pool)
+
+    @patch("hubs.feed.Activity")
+    def test_on_new_message(self, mock_activity):
+        msg = {"_hubs": ["testhub1", "testhub2"]}
+        feed = Mock()
+        mock_activity.return_value = feed
+        on_new_message(msg)
+        call_args = [c[0] for c in mock_activity.call_args_list]
+        self.assertEqual(call_args, [("testhub1", ), ("testhub2", )])
+        self.assertEqual(feed.add.call_count, 2)
+        feed.add.assert_called_with(msg)
+
+    @patch("hubs.feed.Notifications")
+    def test_on_new_notification(self, mock_notifications):
+        feed = Mock()
+        mock_notifications.return_value = feed
+        msg = {"msg_id": "testmsg"}
+        with patch("hubs.feed.fedmsg.meta.msg2agent") as msg2agent:
+            msg2agent.return_value = "ralph"
+            on_new_notification(msg)
+        msg2agent.assert_called()
+        mock_notifications.assert_called_with("ralph")
+        feed.add.assert_called_with(msg)
+
+    @patch("hubs.feed.Notifications")
+    def test_on_new_notification_unknown_user(self, mock_notifications):
+        with patch("hubs.feed.fedmsg.meta.msg2agent") as msg2agent:
+            msg2agent.return_value = "unknown_user"
+            on_new_notification({"msg_id": "testmsg"})
+        msg2agent.assert_called()
+        # User does not exist, no feed instance should have been created.
+        mock_notifications.assert_not_called()
+
+    @patch("hubs.feed.fedmsg.meta.msg2usernames")
+    def test_get_hubs_for_msg(self, msg2usernames):
+        ralph = User.query.get("ralph")
+        infra = Hub.query.get("infra")
+        test_hub = Hub(name="testhub")
+        self.session.add(test_hub)
+        self.session.add(Association(hub=test_hub, user=ralph, role="member"))
+        self.session.add(Association(hub=infra, user=ralph, role="owner"))
+        msg2usernames.return_value = ["unknown_user", "ralph"]
+        self.assertListEqual(
+            sorted(get_hubs_for_msg({"msg_id": "testmsg"})),
+            ["infra", "ralph", "testhub"]
+            )
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 64ebb81..0306821 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -3,7 +3,7 @@ from __future__ import unicode_literals, absolute_import
 import flask
 import json
 import hubs.models
-import hubs.stream
+import hubs.feed
 
 from hubs.app import app
 from hubs.utils.views import (
@@ -29,8 +29,8 @@ def stream():
 @login_required
 def stream_existing():
     username = flask.g.auth.user.username
-    stream = hubs.stream.Stream()
-    existing = json.loads(stream.get_json())
+    feed = hubs.feed.Notifications(username)
+    existing = feed.get()  # TODO: paging?
     # Right now, stream and actions are the same.
     # Once mentions is implemented, then each will be its own.
     return flask.jsonify(dict(
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index 6f7d07a..f8ed081 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -1,11 +1,16 @@
-from __future__ import unicode_literals
+from __future__ import unicode_literals, absolute_import
 
 
+import logging
+
+import hubs.feed
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 
-import logging
-log = logging.getLogger('hubs')
+from .functions import GetData
+
+
+log = logging.getLogger('hubs.widgets')
 
 
 class Feed(Widget):
@@ -16,10 +21,10 @@ class Feed(Widget):
     parameters = [
         {
             "name": "username",
-            "label": "Username",
+            "label": "User name",
             "default": None,
             "validator": validators.Username,
-            "help": "A FAS username.",
+            "help": "A user name.",
         }, {
             "name": "message_limit",
             "label": "Message limit",
@@ -27,6 +32,7 @@ class Feed(Widget):
             "validator": validators.Integer,
             "help": "Max number of feed messages to display.",
         }]
+    cached_functions_module = ".functions"
 
 
 class BaseView(WidgetView):
@@ -55,11 +61,8 @@ class ExistingView(WidgetView):
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
-        # Mock data:
-        import hubs.stream
-        import json
-        stream = hubs.stream.Stream()
-        existing = json.loads(stream.get_json())
+        get_data = GetData(instance)
+        existing = get_data()
         return {
             "status": "OK",
             "data": existing,
diff --git a/hubs/widgets/feed/functions.py b/hubs/widgets/feed/functions.py
new file mode 100644
index 0000000..afe2836
--- /dev/null
+++ b/hubs/widgets/feed/functions.py
@@ -0,0 +1,27 @@
+from __future__ import unicode_literals, absolute_import
+
+
+import flask
+import fedmsg.meta
+
+from hubs.feed import Activity, format_msg
+from hubs.widgets.caching import CachedFunction
+
+
+class GetData(CachedFunction):
+    """Get the feed data from Redis and aggregate it."""
+
+    def execute(self):
+        username = self.instance.config["username"]
+        feed = Activity(username)
+        raw_msgs = feed.get()  # TODO: paging?
+        msgs = fedmsg.meta.conglomerate(raw_msgs)
+        msgs = [format_msg(msg) for msg in msgs]
+        limit = self.instance.config["message_limit"]
+        return msgs[:limit]
+
+    def should_invalidate(self, message):
+        if "_hubs" not in message:
+            return False
+        username = self.instance.config["username"]
+        return (username in message["_hubs"])
